# Luxsci::AuthenticationApi

All URIs are relative to *https://rest.luxsci.com/perl/api/v2*, unless a hostname is provided ([see README](../README.md#documentation-for-api-endpoints))

Method | HTTP request | Description
------------- | ------------- | -------------
[**authentication**](AuthenticationApi.md#authentication) | **POST** /auth | 
[**revoke_authentication**](AuthenticationApi.md#revoke_authentication) | **DELETE** /auth | 

# **authentication**
> InlineResponse201 authentication(opts)



In order to use any API commands, at any level, your client must first authenticate and obtain an authentication code. This authentication code can then be used to make one or more calls to API functions.    our authentication \"session\" can also be revoked, immediately invalidating all authentication codes received for it (i.e., this is a \"log out\").   In order to authenticate, you will need your API Token, API Key, and your API Host name. This API request is different from authenticated request in that you do not need to send a cookie, and the way that the request is signed is different.  See also [Authentication](/rest-api/mechanics.html#auth).

### Example
```ruby
# load the gem
require 'luxsci'

api_instance = Luxsci::AuthenticationApi.new
opts = { 
  body: Luxsci::AuthBody.new # AuthBody | 
}

begin
  result = api_instance.authentication(opts)
  p result
rescue Luxsci::ApiError => e
  puts "Exception when calling AuthenticationApi->authentication: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**AuthBody**](AuthBody.md)|  | [optional] 

### Return type

[**InlineResponse201**](InlineResponse201.md)

### Authorization

Authorization handled with secret key and public token provided

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json



# **authentication**
> InlineResponse201 authentication(opts)



In order to use any API commands, at any level, your client must first authenticate and obtain an authentication code. This authentication code can then be used to make one or more calls to API functions.    our authentication "session" can also be revoked, immediately invalidating all authentication codes received for it (i.e., this is a "log out").   In order to authenticate, you will need your API Token, API Key, and your API Host name. This API request is different from authenticated request in that you do not need to send a cookie, and the way that the request is signed is different.  See also [Authentication](/rest-api/mechanics.html#auth).

### Example
```ruby
# load the gem
require 'luxsci'

api_instance = Luxsci::AuthenticationApi.new
opts = { 
  secret: "SECRET",
  token: "TOKEN"
}

begin
  result = api_instance.authentication(opts)
  p result
rescue Luxsci::ApiError => e
  puts "Exception when calling AuthenticationApi->authentication: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **secret** | **String**|  | [optional] 
 **token** | **String**|  | [optional] 
 **user** | **String**|  | [optional] 
 **pass** | **String**|  | [optional] 

### Return type

[**InlineResponse201**](InlineResponse201.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

# **revoke_authentication**
> InlineResponse200 revoke_authentication()



Revoke your authentication session and invalidate all authorization codes received. See also [Revocation](/rest-api/mechanics.html#revoke).

### Example
```ruby
# load the gem
require 'luxsci'

api_instance = Luxsci::AuthenticationApi.new


begin
  result = api_instance.revoke_authentication()
  p result
rescue Luxsci::ApiError => e
  puts "Exception when calling AuthenticationApi->revoke_authentication: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------

### Return type

[**InlineResponse200**](InlineResponse200.md)

### Authorization

Authorization handled with secret key and public token provided

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json



