# Luxsci::Marketing3Api

All URIs are relative to *https://rest.luxsci.com/perl/api/v2*, unless a hostname is provided ([see README](../README.md#documentation-for-api-endpoints))

Method | HTTP request | Description
------------- | ------------- | -------------
[**add_campaign**](Marketing3Api.md#add_campaign) | **POST** /user/{username}/marketing/campaigns | 
[**add_contact**](Marketing3Api.md#add_contact) | **POST** /user/{username}/marketing/contact | 
[**add_contacts**](Marketing3Api.md#add_contacts) | **POST** /user/{username}/marketing/contacts | 
[**add_list**](Marketing3Api.md#add_list) | **POST** /user/{username}/marketing/list | 
[**add_list_group**](Marketing3Api.md#add_list_group) | **PUT** /user/{username}/marketing/list_group/{list_group_id} | 
[**delete_campaign**](Marketing3Api.md#delete_campaign) | **DELETE** /user/{username}/marketing/campaign/{campaign_id} | 
[**delete_contact**](Marketing3Api.md#delete_contact) | **DELETE** /user/{username}/marketing/contact/{contact_id} | 
[**delete_list**](Marketing3Api.md#delete_list) | **DELETE** /user/{username}/marketing/list/{list_id} | 
[**delete_list_group**](Marketing3Api.md#delete_list_group) | **DELETE** /user/{username}/marketing/list_group/{list_group_id} | 
[**get_campaign**](Marketing3Api.md#get_campaign) | **GET** /user/{username}/marketing/campaign/{campaign_id} | 
[**get_campaigns**](Marketing3Api.md#get_campaigns) | **GET** /user/{username}/marketing/campaigns | 
[**get_contact**](Marketing3Api.md#get_contact) | **GET** /user/{username}/marketing/contact/{contact_id} | 
[**get_contacts**](Marketing3Api.md#get_contacts) | **GET** /user/{username}/marketing/contacts | 
[**get_list**](Marketing3Api.md#get_list) | **GET** /user/{username}/marketing/list/{list_id} | 
[**get_list_groups**](Marketing3Api.md#get_list_groups) | **GET** /user/{username}/marketing/list_groups | 
[**get_lists**](Marketing3Api.md#get_lists) | **GET** /user/{username}/marketing/lists | 
[**get_report_bounced**](Marketing3Api.md#get_report_bounced) | **GET** /user/{username}/marketing/report/bounced | 
[**get_report_clicked**](Marketing3Api.md#get_report_clicked) | **GET** /user/{username}/marketing/report/clicked | 
[**get_report_complaints**](Marketing3Api.md#get_report_complaints) | **GET** /user/{username}/marketing/report/complaints | 
[**get_report_logs**](Marketing3Api.md#get_report_logs) | **GET** /user/{username}/marketing/report/logs | 
[**get_report_opened**](Marketing3Api.md#get_report_opened) | **GET** /user/{username}/marketing/report/opened | 
[**get_report_unsubscribed**](Marketing3Api.md#get_report_unsubscribed) | **GET** /user/{username}/marketing/report/unsubscribed | 
[**get_report_urls**](Marketing3Api.md#get_report_urls) | **GET** /user/{username}/marketing/report/urls | 
[**update_campaign**](Marketing3Api.md#update_campaign) | **PUT** /user/{username}/marketing/campaign/{campaign_id} | 
[**update_contact**](Marketing3Api.md#update_contact) | **PUT** /user/{username}/marketing/contact/{contact_id} | 
[**update_list**](Marketing3Api.md#update_list) | **PUT** /user/{username}/marketing/list/{list_id} | 
[**update_list_group**](Marketing3Api.md#update_list_group) | **POST** /user/{username}/marketing/list_group/{list_group_id} | 

# **add_campaign**
> InlineResponse20042 add_campaign(username, opts)



Add New Campaign. {{ACL: User Marketing - Campaign Management}}

### Example
```ruby
# load the gem
require 'luxsci'

api_instance = Luxsci::Marketing3Api.new
username = 'username_example' # String | 
opts = { 
  body: Luxsci::SM3CampaignPOSTBody.new # SM3CampaignPOSTBody | 
}

begin
  result = api_instance.add_campaign(username, opts)
  p result
rescue Luxsci::ApiError => e
  puts "Exception when calling Marketing3Api->add_campaign: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **username** | **String**|  | 
 **body** | [**SM3CampaignPOSTBody**](SM3CampaignPOSTBody.md)|  | [optional] 

### Return type

[**InlineResponse20042**](InlineResponse20042.md)

### Authorization

Authorization handled with secret key and public token provided

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json



# **add_contact**
> InlineResponse20040 add_contact(username, opts)



Add New Contact List. {{ACL: User Marketing - Contact Management}}

### Example
```ruby
# load the gem
require 'luxsci'

api_instance = Luxsci::Marketing3Api.new
username = 'username_example' # String | 
opts = { 
  body: nil # Hash<String, String> | 
}

begin
  result = api_instance.add_contact(username, opts)
  p result
rescue Luxsci::ApiError => e
  puts "Exception when calling Marketing3Api->add_contact: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **username** | **String**|  | 
 **body** | [**Hash&lt;String, String&gt;**](Hash.md)|  | [optional] 

### Return type

[**InlineResponse20040**](InlineResponse20040.md)

### Authorization

Authorization handled with secret key and public token provided

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json



# **add_contacts**
> InlineResponse20039 add_contacts(bodyusername, opts)



Add New Contacts in Bulk. {{ACL: User Marketing - Contact Management}}

### Example
```ruby
# load the gem
require 'luxsci'

api_instance = Luxsci::Marketing3Api.new
body = nil # Object | An array of JSON objects containing Contact properties.
username = 'username_example' # String | 
opts = { 
}

begin
  result = api_instance.add_contacts(bodyusername, opts)
  p result
rescue Luxsci::ApiError => e
  puts "Exception when calling Marketing3Api->add_contacts: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**Object**](Object.md)| An array of JSON objects containing Contact properties. | 
 **username** | **String**|  | 

### Return type

[**InlineResponse20039**](InlineResponse20039.md)

### Authorization

Authorization handled with secret key and public token provided

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json



# **add_list**
> InlineResponse20035 add_list(bodyusername, opts)



Add New Contact List. {{ACL: User Marketing - List Management}}

### Example
```ruby
# load the gem
require 'luxsci'

api_instance = Luxsci::Marketing3Api.new
body = Luxsci::SM3ListBody.new # SM3ListBody | A JSON object containing List properties.
username = 'username_example' # String | 
opts = { 
}

begin
  result = api_instance.add_list(bodyusername, opts)
  p result
rescue Luxsci::ApiError => e
  puts "Exception when calling Marketing3Api->add_list: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**SM3ListBody**](SM3ListBody.md)| A JSON object containing List properties. | 
 **username** | **String**|  | 

### Return type

[**InlineResponse20035**](InlineResponse20035.md)

### Authorization

Authorization handled with secret key and public token provided

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json



# **add_list_group**
> InlineResponse20037 add_list_group(username, opts)



Create a new email list group. {{ACL: Marketing - List Management}}

### Example
```ruby
# load the gem
require 'luxsci'

api_instance = Luxsci::Marketing3Api.new
username = 'username_example' # String | 
opts = { 
  body: Luxsci::ListGroupListGroupIdBody.new # ListGroupListGroupIdBody | 
}

begin
  result = api_instance.add_list_group(username, opts)
  p result
rescue Luxsci::ApiError => e
  puts "Exception when calling Marketing3Api->add_list_group: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **username** | **String**|  | 
 **body** | [**ListGroupListGroupIdBody**](ListGroupListGroupIdBody.md)|  | [optional] 

### Return type

[**InlineResponse20037**](InlineResponse20037.md)

### Authorization

Authorization handled with secret key and public token provided

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json



# **delete_campaign**
> InlineResponse201 delete_campaign(username, campaign_id, opts)



Delete a campaign.  Note that deleing a campaign will also delete logs and statistics and other data related to that campaign. {{ACL: Marketing - Campaign Management}}

### Example
```ruby
# load the gem
require 'luxsci'

api_instance = Luxsci::Marketing3Api.new
username = 'username_example' # String | 
campaign_id = 'campaign_id_example' # String | Campaign Id.
opts = { 
}

begin
  result = api_instance.delete_campaign(username, campaign_id, opts)
  p result
rescue Luxsci::ApiError => e
  puts "Exception when calling Marketing3Api->delete_campaign: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **username** | **String**|  | 
 **campaign_id** | **String**| Campaign Id. | 

### Return type

[**InlineResponse201**](InlineResponse201.md)

### Authorization

Authorization handled with secret key and public token provided

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json



# **delete_contact**
> InlineResponse201 delete_contact(username, contact_id, opts)



Delete a contact. {{ACL: Marketing - Contact Management}}

### Example
```ruby
# load the gem
require 'luxsci'

api_instance = Luxsci::Marketing3Api.new
username = 'username_example' # String | 
contact_id = 'contact_id_example' # String | List Id.
opts = { 
}

begin
  result = api_instance.delete_contact(username, contact_id, opts)
  p result
rescue Luxsci::ApiError => e
  puts "Exception when calling Marketing3Api->delete_contact: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **username** | **String**|  | 
 **contact_id** | **String**| List Id. | 

### Return type

[**InlineResponse201**](InlineResponse201.md)

### Authorization

Authorization handled with secret key and public token provided

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json



# **delete_list**
> InlineResponse201 delete_list(username, id, opts)



Note: deleting a contact list will delete any contacts in that list. {{ACL: Marketing - List Management}}

### Example
```ruby
# load the gem
require 'luxsci'

api_instance = Luxsci::Marketing3Api.new
username = 'username_example' # String | 
id = 'id_example' # String | List Id.
opts = { 
  contacts_only: 56, # Integer | If passed and true, this call will delete all contacts in the list, but the list itself will not be deleted.
}

begin
  result = api_instance.delete_list(username, id, opts)
  p result
rescue Luxsci::ApiError => e
  puts "Exception when calling Marketing3Api->delete_list: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **username** | **String**|  | 
 **id** | **String**| List Id. | 
 **contacts_only** | **Integer**| If passed and true, this call will delete all contacts in the list, but the list itself will not be deleted. | [optional] 

### Return type

[**InlineResponse201**](InlineResponse201.md)

### Authorization

Authorization handled with secret key and public token provided

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json



# **delete_list_group**
> InlineResponse2003 delete_list_group(username, list_group_id, opts)



Delete a specific email list group.  {{ACL: Marketing - List Management}}

### Example
```ruby
# load the gem
require 'luxsci'

api_instance = Luxsci::Marketing3Api.new
username = 'username_example' # String | 
list_group_id = 'list_group_id_example' # String | Unique Id for this list group.
opts = { 
}

begin
  result = api_instance.delete_list_group(username, list_group_id, opts)
  p result
rescue Luxsci::ApiError => e
  puts "Exception when calling Marketing3Api->delete_list_group: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **username** | **String**|  | 
 **list_group_id** | **String**| Unique Id for this list group. | 

### Return type

[**InlineResponse2003**](InlineResponse2003.md)

### Authorization

Authorization handled with secret key and public token provided

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json



# **get_campaign**
> InlineResponse20043 get_campaign(username, campaign_id, opts)



Return details about the specified Campaign. {{ACL: User: Marketing - Campaign Management}}

### Example
```ruby
# load the gem
require 'luxsci'

api_instance = Luxsci::Marketing3Api.new
username = 'username_example' # String | 
campaign_id = 56 # Integer | Campaign id for the specific campaign you want details for.
opts = { 
}

begin
  result = api_instance.get_campaign(username, campaign_id, opts)
  p result
rescue Luxsci::ApiError => e
  puts "Exception when calling Marketing3Api->get_campaign: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **username** | **String**|  | 
 **campaign_id** | **Integer**| Campaign id for the specific campaign you want details for. | 

### Return type

[**InlineResponse20043**](InlineResponse20043.md)

### Authorization

Authorization handled with secret key and public token provided

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json



# **get_campaigns**
> InlineResponse20034 get_campaigns(username, opts)



Return summary data of all visible Campaigns. The Campaign creation date is used with date matching criteria. See also [API Reporting Basics](/rest-api/reporting.html) and [report header columns in the response.](/rest-api/report-responses.html#sm3_campaigns) {{ACL: User: Marketing - Reporting}}

### Example
```ruby
# load the gem
require 'luxsci'

api_instance = Luxsci::Marketing3Api.new
username = 'username_example' # String | 
opts = { 
  user_id: 56, # Integer | Select campaigns owned by the given user ID.
  status: 'status_example', # String | Campaign Status Enum.
  use_date: 'created', # String | This report uses the Campaign created date by default for all date-related filtering and sorting.  Set this parameter to \"modified\" to instead used the modified date.  Set it to \"send_at\" to use the date/time that the Campaign is scheduled to be sent.  Any other value passed in this parameter will cause the \"created\" date to be used.
  after_date: 'after_date_example', # String | DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT
  before_date: 'before_date_example', # String | DATETIME. Return only matches dated before this date time.
  first_row: 0, # Integer | (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row=50000 to get rows 50000 to 99,999.
  from_date: 'from_date_example', # String | DATETIME. Return only matches dated on or after this date time.
  matches: 50000, # Integer | (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets.
  through_date: 'through_date_example', # String | DATETIME. Return only matches dated before or on this date time.
  destination: 'destination_example', # String | For reporting requests.  Specifying a destination makes the report \"asynchronous.\"  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \"job number\" and the filename that will be uploaded.  The supported value of \"destination\" is currently only \"sftp\" for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \"destination\" is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance.
  destination_directory: 'destination_directory_example', # String | For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \"chdir\" command.
  destination_hostname: 'destination_hostname_example', # String | For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded.
  destination_password: 'destination_password_example', # String | For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded.
  destination_username: 'destination_username_example' # String | For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded.
}

begin
  result = api_instance.get_campaigns(username, opts)
  p result
rescue Luxsci::ApiError => e
  puts "Exception when calling Marketing3Api->get_campaigns: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **username** | **String**|  | 
 **user_id** | **Integer**| Select campaigns owned by the given user ID. | [optional] 
 **status** | **String**| Campaign Status Enum. | [optional] 
 **use_date** | **String**| This report uses the Campaign created date by default for all date-related filtering and sorting.  Set this parameter to \&quot;modified\&quot; to instead used the modified date.  Set it to \&quot;send_at\&quot; to use the date/time that the Campaign is scheduled to be sent.  Any other value passed in this parameter will cause the \&quot;created\&quot; date to be used. | [optional] [default to created]
 **after_date** | **String**| DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT | [optional] 
 **before_date** | **String**| DATETIME. Return only matches dated before this date time. | [optional] 
 **first_row** | **Integer**| (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row&#x3D;50000 to get rows 50000 to 99,999. | [optional] [default to 0]
 **from_date** | **String**| DATETIME. Return only matches dated on or after this date time. | [optional] 
 **matches** | **Integer**| (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets. | [optional] [default to 50000]
 **through_date** | **String**| DATETIME. Return only matches dated before or on this date time. | [optional] 
 **destination** | **String**| For reporting requests.  Specifying a destination makes the report \&quot;asynchronous.\&quot;  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \&quot;job number\&quot; and the filename that will be uploaded.  The supported value of \&quot;destination\&quot; is currently only \&quot;sftp\&quot; for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \&quot;destination\&quot; is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance. | [optional] 
 **destination_directory** | **String**| For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \&quot;chdir\&quot; command. | [optional] 
 **destination_hostname** | **String**| For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded. | [optional] 
 **destination_password** | **String**| For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded. | [optional] 
 **destination_username** | **String**| For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded. | [optional] 

### Return type

[**InlineResponse20034**](InlineResponse20034.md)

### Authorization

Authorization handled with secret key and public token provided

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json



# **get_contact**
> InlineResponse20041 get_contact(username, contact_id, opts)



Return the specified Contact. {{ACL: Marketing - Contact Management}}

### Example
```ruby
# load the gem
require 'luxsci'

api_instance = Luxsci::Marketing3Api.new
username = 'username_example' # String | 
contact_id = 56 # Integer | Contact id for the specific contact list you want details for.
opts = { 
  details: 56, # Integer | If details=1 (default) return custom fields.
}

begin
  result = api_instance.get_contact(username, contact_id, opts)
  p result
rescue Luxsci::ApiError => e
  puts "Exception when calling Marketing3Api->get_contact: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **username** | **String**|  | 
 **contact_id** | **Integer**| Contact id for the specific contact list you want details for. | 
 **details** | **Integer**| If details&#x3D;1 (default) return custom fields. | [optional] 

### Return type

[**InlineResponse20041**](InlineResponse20041.md)

### Authorization

Authorization handled with secret key and public token provided

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json



# **get_contacts**
> InlineResponse20034 get_contacts(username, opts)



Return all Contacts in the specified List.  If no list is specified, then all contacts across all lists will be returned.  The contact creation date is used with date matching criteria. See also [API Reporting Basics](/rest-api/reporting.html) and [report header columns in the response.](/rest-api/report-responses.html#sm3_contacts) {{ACL: Marketing - Reports}}

### Example
```ruby
# load the gem
require 'luxsci'

api_instance = Luxsci::Marketing3Api.new
username = 'username_example' # String | 
opts = { 
  use_date: 'created', # String | This report uses the created date by default for all date-related filtering and sorting.  Set this parameter to \"modified\" to instead used the modified date. Any other value passed in this parameter will cause the \"created\" date to be used.
  after_date: 'after_date_example', # String | DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT
  before_date: 'before_date_example', # String | DATETIME. Return only matches dated before this date time.
  first_row: 0, # Integer | (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row=50000 to get rows 50000 to 99,999.
  from_date: 'from_date_example', # String | DATETIME. Return only matches dated on or after this date time.
  matches: 50000, # Integer | (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets.
  through_date: 'through_date_example', # String | DATETIME. Return only matches dated before or on this date time.
  destination: 'destination_example', # String | For reporting requests.  Specifying a destination makes the report \"asynchronous.\"  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \"job number\" and the filename that will be uploaded.  The supported value of \"destination\" is currently only \"sftp\" for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \"destination\" is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance.
  destination_directory: 'destination_directory_example', # String | For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \"chdir\" command.
  destination_hostname: 'destination_hostname_example', # String | For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded.
  destination_password: 'destination_password_example', # String | For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded.
  destination_username: 'destination_username_example', # String | For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded.
  list_id: 56, # Integer | List id to get all contacts in a specific List. If this is omitted, then all contacts across all Lists will be returned.
  segment_id: 56, # Integer | Segment id to get all contacts in a specific Segment.  Note that you can specify both a segment_id and a list_id to get contacts in a specific List that are also in a specific Segment.
  details: 56, # Integer | Whe nset to true (1), data for all custom fields will also be included in the response.
}

begin
  result = api_instance.get_contacts(username, opts)
  p result
rescue Luxsci::ApiError => e
  puts "Exception when calling Marketing3Api->get_contacts: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **username** | **String**|  | 
 **use_date** | **String**| This report uses the created date by default for all date-related filtering and sorting.  Set this parameter to \&quot;modified\&quot; to instead used the modified date. Any other value passed in this parameter will cause the \&quot;created\&quot; date to be used. | [optional] [default to created]
 **after_date** | **String**| DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT | [optional] 
 **before_date** | **String**| DATETIME. Return only matches dated before this date time. | [optional] 
 **first_row** | **Integer**| (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row&#x3D;50000 to get rows 50000 to 99,999. | [optional] [default to 0]
 **from_date** | **String**| DATETIME. Return only matches dated on or after this date time. | [optional] 
 **matches** | **Integer**| (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets. | [optional] [default to 50000]
 **through_date** | **String**| DATETIME. Return only matches dated before or on this date time. | [optional] 
 **destination** | **String**| For reporting requests.  Specifying a destination makes the report \&quot;asynchronous.\&quot;  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \&quot;job number\&quot; and the filename that will be uploaded.  The supported value of \&quot;destination\&quot; is currently only \&quot;sftp\&quot; for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \&quot;destination\&quot; is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance. | [optional] 
 **destination_directory** | **String**| For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \&quot;chdir\&quot; command. | [optional] 
 **destination_hostname** | **String**| For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded. | [optional] 
 **destination_password** | **String**| For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded. | [optional] 
 **destination_username** | **String**| For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded. | [optional] 
 **list_id** | **Integer**| List id to get all contacts in a specific List. If this is omitted, then all contacts across all Lists will be returned. | [optional] 
 **segment_id** | **Integer**| Segment id to get all contacts in a specific Segment.  Note that you can specify both a segment_id and a list_id to get contacts in a specific List that are also in a specific Segment. | [optional] 
 **details** | **Integer**| Whe nset to true (1), data for all custom fields will also be included in the response. | [optional] 

### Return type

[**InlineResponse20034**](InlineResponse20034.md)

### Authorization

Authorization handled with secret key and public token provided

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json



# **get_list**
> InlineResponse20036 get_list(username, list_id, opts)



Return details about the specified Contact List. {{ACL: Marketing - List Management}}

### Example
```ruby
# load the gem
require 'luxsci'

api_instance = Luxsci::Marketing3Api.new
username = 'username_example' # String | 
list_id = 56 # Integer | List id for the specific contact list you want details for.
opts = { 
}

begin
  result = api_instance.get_list(username, list_id, opts)
  p result
rescue Luxsci::ApiError => e
  puts "Exception when calling Marketing3Api->get_list: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **username** | **String**|  | 
 **list_id** | **Integer**| List id for the specific contact list you want details for. | 

### Return type

[**InlineResponse20036**](InlineResponse20036.md)

### Authorization

Authorization handled with secret key and public token provided

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json



# **get_list_groups**
> InlineResponse20038 get_list_groups(username, opts)



This function returns a list of all lists groups accessible to you.  {{ACL: Marketing - List Management}}

### Example
```ruby
# load the gem
require 'luxsci'

api_instance = Luxsci::Marketing3Api.new
username = 'username_example' # String | 
opts = { 
}

begin
  result = api_instance.get_list_groups(username, opts)
  p result
rescue Luxsci::ApiError => e
  puts "Exception when calling Marketing3Api->get_list_groups: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **username** | **String**|  | 

### Return type

[**InlineResponse20038**](InlineResponse20038.md)

### Authorization

Authorization handled with secret key and public token provided

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json



# **get_lists**
> InlineResponse20034 get_lists(username, opts)



Return all Contact Lists. The list creation date is used with date matching criteria. See also [API Reporting Basics](/rest-api/reporting.html) and [report header columns in the response.](/rest-api/report-responses.html#sm3_lists) {{ACL: Marketing - Reports}}

### Example
```ruby
# load the gem
require 'luxsci'

api_instance = Luxsci::Marketing3Api.new
username = 'username_example' # String | 
opts = { 
  list_group_id: 56, # Integer | Group id getting all lists in a specific group
  use_date: 'created', # String | This report uses the created date by default for all date-related filtering and sorting.  Set this parameter to \"modified\" to instead used the modified date. Any other value passed in this parameter will cause the \"created\" date to be used.
  after_date: 'after_date_example', # String | DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT
  before_date: 'before_date_example', # String | DATETIME. Return only matches dated before this date time.
  first_row: 0, # Integer | (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row=50000 to get rows 50000 to 99,999.
  from_date: 'from_date_example', # String | DATETIME. Return only matches dated on or after this date time.
  matches: 50000, # Integer | (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets.
  through_date: 'through_date_example', # String | DATETIME. Return only matches dated before or on this date time.
  destination: 'destination_example', # String | For reporting requests.  Specifying a destination makes the report \"asynchronous.\"  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \"job number\" and the filename that will be uploaded.  The supported value of \"destination\" is currently only \"sftp\" for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \"destination\" is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance.
  destination_directory: 'destination_directory_example', # String | For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \"chdir\" command.
  destination_hostname: 'destination_hostname_example', # String | For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded.
  destination_password: 'destination_password_example', # String | For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded.
  destination_username: 'destination_username_example' # String | For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded.
}

begin
  result = api_instance.get_lists(username, opts)
  p result
rescue Luxsci::ApiError => e
  puts "Exception when calling Marketing3Api->get_lists: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **username** | **String**|  | 
 **list_group_id** | **Integer**| Group id getting all lists in a specific group | [optional] 
 **use_date** | **String**| This report uses the created date by default for all date-related filtering and sorting.  Set this parameter to \&quot;modified\&quot; to instead used the modified date. Any other value passed in this parameter will cause the \&quot;created\&quot; date to be used. | [optional] [default to created]
 **after_date** | **String**| DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT | [optional] 
 **before_date** | **String**| DATETIME. Return only matches dated before this date time. | [optional] 
 **first_row** | **Integer**| (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row&#x3D;50000 to get rows 50000 to 99,999. | [optional] [default to 0]
 **from_date** | **String**| DATETIME. Return only matches dated on or after this date time. | [optional] 
 **matches** | **Integer**| (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets. | [optional] [default to 50000]
 **through_date** | **String**| DATETIME. Return only matches dated before or on this date time. | [optional] 
 **destination** | **String**| For reporting requests.  Specifying a destination makes the report \&quot;asynchronous.\&quot;  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \&quot;job number\&quot; and the filename that will be uploaded.  The supported value of \&quot;destination\&quot; is currently only \&quot;sftp\&quot; for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \&quot;destination\&quot; is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance. | [optional] 
 **destination_directory** | **String**| For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \&quot;chdir\&quot; command. | [optional] 
 **destination_hostname** | **String**| For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded. | [optional] 
 **destination_password** | **String**| For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded. | [optional] 
 **destination_username** | **String**| For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded. | [optional] 

### Return type

[**InlineResponse20034**](InlineResponse20034.md)

### Authorization

Authorization handled with secret key and public token provided

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json



# **get_report_bounced**
> InlineResponse20034 get_report_bounced(username, opts)



Return bounce data/email delivery failure data of all selected Campaigns. Uses delivery_status_updated as the date matching criteria. See also [API Reporting Basics](/rest-api/reporting.html) and [report header columns in the response.](/rest-api/report-responses.html#sm3_campaign_report_bounces) {{ACL: User: Marketing - Reporting}}

### Example
```ruby
# load the gem
require 'luxsci'

api_instance = Luxsci::Marketing3Api.new
username = 'username_example' # String | 
opts = { 
  campaign_ids: 'campaign_ids_example', # String | Select campaigns as string of comma-separated campaign ids.  If omitted, all campaigns are selected.
  detail: 'detail_example', # String | Boolean.  If 1, include the values of all Contact Custom Fields in the report. Default is 0.
  email: 'email_example', # String | Filter results by matching any Contact email address containing the given string.
  domain: 'domain_example', # String | Filter results by matching any Contact email address in a domain name containing the given string.
  after_date: 'after_date_example', # String | DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT
  before_date: 'before_date_example', # String | DATETIME. Return only matches dated before this date time.
  first_row: 0, # Integer | (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row=50000 to get rows 50000 to 99,999.
  from_date: 'from_date_example', # String | DATETIME. Return only matches dated on or after this date time.
  matches: 50000, # Integer | (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets.
  through_date: 'through_date_example', # String | DATETIME. Return only matches dated before or on this date time.
  destination: 'destination_example', # String | For reporting requests.  Specifying a destination makes the report \"asynchronous.\"  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \"job number\" and the filename that will be uploaded.  The supported value of \"destination\" is currently only \"sftp\" for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \"destination\" is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance.
  destination_directory: 'destination_directory_example', # String | For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \"chdir\" command.
  destination_hostname: 'destination_hostname_example', # String | For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded.
  destination_password: 'destination_password_example', # String | For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded.
  destination_username: 'destination_username_example' # String | For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded.
}

begin
  result = api_instance.get_report_bounced(username, opts)
  p result
rescue Luxsci::ApiError => e
  puts "Exception when calling Marketing3Api->get_report_bounced: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **username** | **String**|  | 
 **campaign_ids** | **String**| Select campaigns as string of comma-separated campaign ids.  If omitted, all campaigns are selected. | [optional] 
 **detail** | **String**| Boolean.  If 1, include the values of all Contact Custom Fields in the report. Default is 0. | [optional] 
 **email** | **String**| Filter results by matching any Contact email address containing the given string. | [optional] 
 **domain** | **String**| Filter results by matching any Contact email address in a domain name containing the given string. | [optional] 
 **after_date** | **String**| DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT | [optional] 
 **before_date** | **String**| DATETIME. Return only matches dated before this date time. | [optional] 
 **first_row** | **Integer**| (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row&#x3D;50000 to get rows 50000 to 99,999. | [optional] [default to 0]
 **from_date** | **String**| DATETIME. Return only matches dated on or after this date time. | [optional] 
 **matches** | **Integer**| (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets. | [optional] [default to 50000]
 **through_date** | **String**| DATETIME. Return only matches dated before or on this date time. | [optional] 
 **destination** | **String**| For reporting requests.  Specifying a destination makes the report \&quot;asynchronous.\&quot;  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \&quot;job number\&quot; and the filename that will be uploaded.  The supported value of \&quot;destination\&quot; is currently only \&quot;sftp\&quot; for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \&quot;destination\&quot; is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance. | [optional] 
 **destination_directory** | **String**| For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \&quot;chdir\&quot; command. | [optional] 
 **destination_hostname** | **String**| For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded. | [optional] 
 **destination_password** | **String**| For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded. | [optional] 
 **destination_username** | **String**| For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded. | [optional] 

### Return type

[**InlineResponse20034**](InlineResponse20034.md)

### Authorization

Authorization handled with secret key and public token provided

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json



# **get_report_clicked**
> InlineResponse20034 get_report_clicked(username, opts)



Return click data of all selected Campaigns. The click date is used with date matching criteria unless the \"use_date\" parameter is set to \"sent\". See also [API Reporting Basics](/rest-api/reporting.html) and [report header columns in the response.](/rest-api/report-responses.html#sm3_campaign_report_clicked) {{ACL: User: Marketing - Reporting}}

### Example
```ruby
# load the gem
require 'luxsci'

api_instance = Luxsci::Marketing3Api.new
username = 'username_example' # String | 
opts = { 
  campaign_ids: 'campaign_ids_example', # String | Select campaigns as string of comma-separated campaign ids.  If omitted, all campaigns are selected.
  use_date: 'use_date_example', # String | If set to \"sent\", use the date the message was sent, instead of the date of the open event, for date selections.
  detail: 'detail_example', # String | Boolean.  If 1, include the values of all Contact Custom Fields in the report. Default is 0.
  email: 'email_example', # String | Filter results by matching any Contact email address containing the given string.
  domain: 'domain_example', # String | Filter results by matching any Contact email address in a domain name containing the given string.
  after_date: 'after_date_example', # String | DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT
  before_date: 'before_date_example', # String | DATETIME. Return only matches dated before this date time.
  first_row: 0, # Integer | (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row=50000 to get rows 50000 to 99,999.
  from_date: 'from_date_example', # String | DATETIME. Return only matches dated on or after this date time.
  matches: 50000, # Integer | (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets.
  through_date: 'through_date_example', # String | DATETIME. Return only matches dated before or on this date time.
  destination: 'destination_example', # String | For reporting requests.  Specifying a destination makes the report \"asynchronous.\"  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \"job number\" and the filename that will be uploaded.  The supported value of \"destination\" is currently only \"sftp\" for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \"destination\" is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance.
  destination_directory: 'destination_directory_example', # String | For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \"chdir\" command.
  destination_hostname: 'destination_hostname_example', # String | For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded.
  destination_password: 'destination_password_example', # String | For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded.
  destination_username: 'destination_username_example' # String | For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded.
}

begin
  result = api_instance.get_report_clicked(username, opts)
  p result
rescue Luxsci::ApiError => e
  puts "Exception when calling Marketing3Api->get_report_clicked: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **username** | **String**|  | 
 **campaign_ids** | **String**| Select campaigns as string of comma-separated campaign ids.  If omitted, all campaigns are selected. | [optional] 
 **use_date** | **String**| If set to \&quot;sent\&quot;, use the date the message was sent, instead of the date of the open event, for date selections. | [optional] 
 **detail** | **String**| Boolean.  If 1, include the values of all Contact Custom Fields in the report. Default is 0. | [optional] 
 **email** | **String**| Filter results by matching any Contact email address containing the given string. | [optional] 
 **domain** | **String**| Filter results by matching any Contact email address in a domain name containing the given string. | [optional] 
 **after_date** | **String**| DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT | [optional] 
 **before_date** | **String**| DATETIME. Return only matches dated before this date time. | [optional] 
 **first_row** | **Integer**| (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row&#x3D;50000 to get rows 50000 to 99,999. | [optional] [default to 0]
 **from_date** | **String**| DATETIME. Return only matches dated on or after this date time. | [optional] 
 **matches** | **Integer**| (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets. | [optional] [default to 50000]
 **through_date** | **String**| DATETIME. Return only matches dated before or on this date time. | [optional] 
 **destination** | **String**| For reporting requests.  Specifying a destination makes the report \&quot;asynchronous.\&quot;  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \&quot;job number\&quot; and the filename that will be uploaded.  The supported value of \&quot;destination\&quot; is currently only \&quot;sftp\&quot; for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \&quot;destination\&quot; is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance. | [optional] 
 **destination_directory** | **String**| For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \&quot;chdir\&quot; command. | [optional] 
 **destination_hostname** | **String**| For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded. | [optional] 
 **destination_password** | **String**| For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded. | [optional] 
 **destination_username** | **String**| For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded. | [optional] 

### Return type

[**InlineResponse20034**](InlineResponse20034.md)

### Authorization

Authorization handled with secret key and public token provided

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json



# **get_report_complaints**
> InlineResponse20034 get_report_complaints(username, opts)



Return spam complaint data from all selected Campaigns. The message delivery status updated date is used by default for date selections, unless \"use_date\" is set to \"sent\". See also [API Reporting Basics](/rest-api/reporting.html) and [report header columns in the response.](/rest-api/report-responses.html#sm3_campaign_report_complaints) {{ACL: User: Marketing - Reporting}}

### Example
```ruby
# load the gem
require 'luxsci'

api_instance = Luxsci::Marketing3Api.new
username = 'username_example' # String | 
opts = { 
  campaign_ids: 'campaign_ids_example', # String | Select campaigns as string of comma-separated campaign ids.  If omitted, all campaigns are selected.
  use_date: 'use_date_example', # String | If set to \"sent\", use the date the message was sent, instead of the date of the open event, for date selections.
  detail: 'detail_example', # String | Boolean.  If 1, include the values of all Contact Custom Fields in the report. Default is 0.
  email: 'email_example', # String | Filter results by matching any Contact email address containing the given string.
  domain: 'domain_example', # String | Filter results by matching any Contact email address in a domain name containing the given string.
  after_date: 'after_date_example', # String | DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT
  before_date: 'before_date_example', # String | DATETIME. Return only matches dated before this date time.
  first_row: 0, # Integer | (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row=50000 to get rows 50000 to 99,999.
  from_date: 'from_date_example', # String | DATETIME. Return only matches dated on or after this date time.
  matches: 50000, # Integer | (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets.
  through_date: 'through_date_example', # String | DATETIME. Return only matches dated before or on this date time.
  destination: 'destination_example', # String | For reporting requests.  Specifying a destination makes the report \"asynchronous.\"  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \"job number\" and the filename that will be uploaded.  The supported value of \"destination\" is currently only \"sftp\" for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \"destination\" is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance.
  destination_directory: 'destination_directory_example', # String | For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \"chdir\" command.
  destination_hostname: 'destination_hostname_example', # String | For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded.
  destination_password: 'destination_password_example', # String | For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded.
  destination_username: 'destination_username_example' # String | For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded.
}

begin
  result = api_instance.get_report_complaints(username, opts)
  p result
rescue Luxsci::ApiError => e
  puts "Exception when calling Marketing3Api->get_report_complaints: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **username** | **String**|  | 
 **campaign_ids** | **String**| Select campaigns as string of comma-separated campaign ids.  If omitted, all campaigns are selected. | [optional] 
 **use_date** | **String**| If set to \&quot;sent\&quot;, use the date the message was sent, instead of the date of the open event, for date selections. | [optional] 
 **detail** | **String**| Boolean.  If 1, include the values of all Contact Custom Fields in the report. Default is 0. | [optional] 
 **email** | **String**| Filter results by matching any Contact email address containing the given string. | [optional] 
 **domain** | **String**| Filter results by matching any Contact email address in a domain name containing the given string. | [optional] 
 **after_date** | **String**| DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT | [optional] 
 **before_date** | **String**| DATETIME. Return only matches dated before this date time. | [optional] 
 **first_row** | **Integer**| (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row&#x3D;50000 to get rows 50000 to 99,999. | [optional] [default to 0]
 **from_date** | **String**| DATETIME. Return only matches dated on or after this date time. | [optional] 
 **matches** | **Integer**| (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets. | [optional] [default to 50000]
 **through_date** | **String**| DATETIME. Return only matches dated before or on this date time. | [optional] 
 **destination** | **String**| For reporting requests.  Specifying a destination makes the report \&quot;asynchronous.\&quot;  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \&quot;job number\&quot; and the filename that will be uploaded.  The supported value of \&quot;destination\&quot; is currently only \&quot;sftp\&quot; for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \&quot;destination\&quot; is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance. | [optional] 
 **destination_directory** | **String**| For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \&quot;chdir\&quot; command. | [optional] 
 **destination_hostname** | **String**| For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded. | [optional] 
 **destination_password** | **String**| For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded. | [optional] 
 **destination_username** | **String**| For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded. | [optional] 

### Return type

[**InlineResponse20034**](InlineResponse20034.md)

### Authorization

Authorization handled with secret key and public token provided

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json



# **get_report_logs**
> InlineResponse20034 get_report_logs(username, opts)



Return sending log data of all selected Campaigns.  This includes all metadata for each recipient, including the delivery status, open status, click staus, etc.  The delivery status last updated date is used with date matching criteria. See also [API Reporting Basics](/rest-api/reporting.html) and [report header columns in the response.](/rest-api/report-responses.html#sm3_campaign_report_logs) {{ACL: User: Marketing - Reporting}}

### Example
```ruby
# load the gem
require 'luxsci'

api_instance = Luxsci::Marketing3Api.new
username = 'username_example' # String | 
opts = { 
  campaign_ids: 'campaign_ids_example', # String | Select campaigns as string of comma-separated campaign ids. If omitted, all campaigns are selected.
  detail: 'detail_example', # String | Boolean.  If 1, include the values of all Contact Custom Fields in the report. Default is 0.
  email: 'email_example', # String | Filter results by matching any Contact email address containing the given string.
  domain: 'domain_example', # String | Filter results by matching any Contact email address in a domain name containing the given string.
  after_date: 'after_date_example', # String | DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT
  before_date: 'before_date_example', # String | DATETIME. Return only matches dated before this date time.
  first_row: 0, # Integer | (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row=50000 to get rows 50000 to 99,999.
  from_date: 'from_date_example', # String | DATETIME. Return only matches dated on or after this date time.
  matches: 50000, # Integer | (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets.
  through_date: 'through_date_example', # String | DATETIME. Return only matches dated before or on this date time.
  destination: 'destination_example', # String | For reporting requests.  Specifying a destination makes the report \"asynchronous.\"  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \"job number\" and the filename that will be uploaded.  The supported value of \"destination\" is currently only \"sftp\" for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \"destination\" is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance.
  destination_directory: 'destination_directory_example', # String | For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \"chdir\" command.
  destination_hostname: 'destination_hostname_example', # String | For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded.
  destination_password: 'destination_password_example', # String | For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded.
  destination_username: 'destination_username_example' # String | For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded.
}

begin
  result = api_instance.get_report_logs(username, opts)
  p result
rescue Luxsci::ApiError => e
  puts "Exception when calling Marketing3Api->get_report_logs: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **username** | **String**|  | 
 **campaign_ids** | **String**| Select campaigns as string of comma-separated campaign ids. If omitted, all campaigns are selected. | [optional] 
 **detail** | **String**| Boolean.  If 1, include the values of all Contact Custom Fields in the report. Default is 0. | [optional] 
 **email** | **String**| Filter results by matching any Contact email address containing the given string. | [optional] 
 **domain** | **String**| Filter results by matching any Contact email address in a domain name containing the given string. | [optional] 
 **after_date** | **String**| DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT | [optional] 
 **before_date** | **String**| DATETIME. Return only matches dated before this date time. | [optional] 
 **first_row** | **Integer**| (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row&#x3D;50000 to get rows 50000 to 99,999. | [optional] [default to 0]
 **from_date** | **String**| DATETIME. Return only matches dated on or after this date time. | [optional] 
 **matches** | **Integer**| (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets. | [optional] [default to 50000]
 **through_date** | **String**| DATETIME. Return only matches dated before or on this date time. | [optional] 
 **destination** | **String**| For reporting requests.  Specifying a destination makes the report \&quot;asynchronous.\&quot;  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \&quot;job number\&quot; and the filename that will be uploaded.  The supported value of \&quot;destination\&quot; is currently only \&quot;sftp\&quot; for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \&quot;destination\&quot; is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance. | [optional] 
 **destination_directory** | **String**| For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \&quot;chdir\&quot; command. | [optional] 
 **destination_hostname** | **String**| For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded. | [optional] 
 **destination_password** | **String**| For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded. | [optional] 
 **destination_username** | **String**| For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded. | [optional] 

### Return type

[**InlineResponse20034**](InlineResponse20034.md)

### Authorization

Authorization handled with secret key and public token provided

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json



# **get_report_opened**
> InlineResponse20034 get_report_opened(username, opts)



Return open event data of all selected Campaigns. The open date is used with date matching criteria, unless the \"use_date\" parameter is set to \"sent\". See also [API Reporting Basics](/rest-api/reporting.html) and [report header columns in the response.](/rest-api/report-responses.html#sm3_campaign_report_opened) {{ACL: User: Marketing - Reporting}}

### Example
```ruby
# load the gem
require 'luxsci'

api_instance = Luxsci::Marketing3Api.new
username = 'username_example' # String | 
opts = { 
  campaign_ids: 'campaign_ids_example', # String | Select campaigns as string of comma-separated campaign ids. If omitted, all campaigns are selected.
  use_date: 'use_date_example', # String | If set to \"sent\", use the date the message was sent, instead of the date of the open event, for date selections.
  detail: 'detail_example', # String | Boolean.  If 1, include the values of all Contact Custom Fields in the report. Default is 0.
  email: 'email_example', # String | Filter results by matching any Contact email address containing the given string.
  domain: 'domain_example', # String | Filter results by matching any Contact email address in a domain name containing the given string.
  after_date: 'after_date_example', # String | DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT
  before_date: 'before_date_example', # String | DATETIME. Return only matches dated before this date time.
  first_row: 0, # Integer | (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row=50000 to get rows 50000 to 99,999.
  from_date: 'from_date_example', # String | DATETIME. Return only matches dated on or after this date time.
  matches: 50000, # Integer | (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets.
  through_date: 'through_date_example', # String | DATETIME. Return only matches dated before or on this date time.
  destination: 'destination_example', # String | For reporting requests.  Specifying a destination makes the report \"asynchronous.\"  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \"job number\" and the filename that will be uploaded.  The supported value of \"destination\" is currently only \"sftp\" for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \"destination\" is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance.
  destination_directory: 'destination_directory_example', # String | For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \"chdir\" command.
  destination_hostname: 'destination_hostname_example', # String | For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded.
  destination_password: 'destination_password_example', # String | For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded.
  destination_username: 'destination_username_example' # String | For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded.
}

begin
  result = api_instance.get_report_opened(username, opts)
  p result
rescue Luxsci::ApiError => e
  puts "Exception when calling Marketing3Api->get_report_opened: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **username** | **String**|  | 
 **campaign_ids** | **String**| Select campaigns as string of comma-separated campaign ids. If omitted, all campaigns are selected. | [optional] 
 **use_date** | **String**| If set to \&quot;sent\&quot;, use the date the message was sent, instead of the date of the open event, for date selections. | [optional] 
 **detail** | **String**| Boolean.  If 1, include the values of all Contact Custom Fields in the report. Default is 0. | [optional] 
 **email** | **String**| Filter results by matching any Contact email address containing the given string. | [optional] 
 **domain** | **String**| Filter results by matching any Contact email address in a domain name containing the given string. | [optional] 
 **after_date** | **String**| DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT | [optional] 
 **before_date** | **String**| DATETIME. Return only matches dated before this date time. | [optional] 
 **first_row** | **Integer**| (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row&#x3D;50000 to get rows 50000 to 99,999. | [optional] [default to 0]
 **from_date** | **String**| DATETIME. Return only matches dated on or after this date time. | [optional] 
 **matches** | **Integer**| (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets. | [optional] [default to 50000]
 **through_date** | **String**| DATETIME. Return only matches dated before or on this date time. | [optional] 
 **destination** | **String**| For reporting requests.  Specifying a destination makes the report \&quot;asynchronous.\&quot;  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \&quot;job number\&quot; and the filename that will be uploaded.  The supported value of \&quot;destination\&quot; is currently only \&quot;sftp\&quot; for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \&quot;destination\&quot; is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance. | [optional] 
 **destination_directory** | **String**| For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \&quot;chdir\&quot; command. | [optional] 
 **destination_hostname** | **String**| For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded. | [optional] 
 **destination_password** | **String**| For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded. | [optional] 
 **destination_username** | **String**| For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded. | [optional] 

### Return type

[**InlineResponse20034**](InlineResponse20034.md)

### Authorization

Authorization handled with secret key and public token provided

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json



# **get_report_unsubscribed**
> InlineResponse20034 get_report_unsubscribed(username, opts)



Return unsubscribe data of all selected Campaigns. The unsubscribe date is used with date matching criteria, unless the \"use_date\" parameter is set to \"sent\". See also [API Reporting Basics](/rest-api/reporting.html) and [report header columns in the response.](/rest-api/report-responses.html#sm3_campaign_report_unsubscribed) {{ACL: User: Marketing - Reporting}}

### Example
```ruby
# load the gem
require 'luxsci'

api_instance = Luxsci::Marketing3Api.new
username = 'username_example' # String | 
opts = { 
  campaign_ids: 'campaign_ids_example', # String | Select campaigns as string of comma-separated campaign ids.  If omitted, all campaigns are selected.
  use_date: 'use_date_example', # String | If set to \"sent\", use the date the message was sent, instead of the date of the open event, for date selections.
  detail: 'detail_example', # String | Boolean.  If 1, include the values of all Contact Custom Fields in the report. Default is 0.
  email: 'email_example', # String | Filter results by matching any Contact email address containing the given string.
  domain: 'domain_example', # String | Filter results by matching any Contact email address in a domain name containing the given string.
  after_date: 'after_date_example', # String | DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT
  before_date: 'before_date_example', # String | DATETIME. Return only matches dated before this date time.
  first_row: 0, # Integer | (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row=50000 to get rows 50000 to 99,999.
  from_date: 'from_date_example', # String | DATETIME. Return only matches dated on or after this date time.
  matches: 50000, # Integer | (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets.
  through_date: 'through_date_example', # String | DATETIME. Return only matches dated before or on this date time.
  destination: 'destination_example', # String | For reporting requests.  Specifying a destination makes the report \"asynchronous.\"  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \"job number\" and the filename that will be uploaded.  The supported value of \"destination\" is currently only \"sftp\" for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \"destination\" is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance.
  destination_directory: 'destination_directory_example', # String | For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \"chdir\" command.
  destination_hostname: 'destination_hostname_example', # String | For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded.
  destination_password: 'destination_password_example', # String | For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded.
  destination_username: 'destination_username_example' # String | For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded.
}

begin
  result = api_instance.get_report_unsubscribed(username, opts)
  p result
rescue Luxsci::ApiError => e
  puts "Exception when calling Marketing3Api->get_report_unsubscribed: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **username** | **String**|  | 
 **campaign_ids** | **String**| Select campaigns as string of comma-separated campaign ids.  If omitted, all campaigns are selected. | [optional] 
 **use_date** | **String**| If set to \&quot;sent\&quot;, use the date the message was sent, instead of the date of the open event, for date selections. | [optional] 
 **detail** | **String**| Boolean.  If 1, include the values of all Contact Custom Fields in the report. Default is 0. | [optional] 
 **email** | **String**| Filter results by matching any Contact email address containing the given string. | [optional] 
 **domain** | **String**| Filter results by matching any Contact email address in a domain name containing the given string. | [optional] 
 **after_date** | **String**| DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT | [optional] 
 **before_date** | **String**| DATETIME. Return only matches dated before this date time. | [optional] 
 **first_row** | **Integer**| (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row&#x3D;50000 to get rows 50000 to 99,999. | [optional] [default to 0]
 **from_date** | **String**| DATETIME. Return only matches dated on or after this date time. | [optional] 
 **matches** | **Integer**| (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets. | [optional] [default to 50000]
 **through_date** | **String**| DATETIME. Return only matches dated before or on this date time. | [optional] 
 **destination** | **String**| For reporting requests.  Specifying a destination makes the report \&quot;asynchronous.\&quot;  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \&quot;job number\&quot; and the filename that will be uploaded.  The supported value of \&quot;destination\&quot; is currently only \&quot;sftp\&quot; for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \&quot;destination\&quot; is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance. | [optional] 
 **destination_directory** | **String**| For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \&quot;chdir\&quot; command. | [optional] 
 **destination_hostname** | **String**| For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded. | [optional] 
 **destination_password** | **String**| For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded. | [optional] 
 **destination_username** | **String**| For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded. | [optional] 

### Return type

[**InlineResponse20034**](InlineResponse20034.md)

### Authorization

Authorization handled with secret key and public token provided

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json



# **get_report_urls**
> InlineResponse20034 get_report_urls(username, opts)



Return clicked-on urls of all selected Campaigns. The click date is used with date matching criteria unless the \"use_date\" parameter is set to \"sent\".  See also [API Reporting Basics](/rest-api/reporting.html) and [report header columns in the response.](/rest-api/report-responses.html#sm3_campaign_report_urls) {{ACL: User: Marketing - Reporting}}

### Example
```ruby
# load the gem
require 'luxsci'

api_instance = Luxsci::Marketing3Api.new
username = 'username_example' # String | 
opts = { 
  campaign_ids: 'campaign_ids_example', # String | Select campaigns as string of comma-separated campaign ids.  If omitted, all campaigns are selected.
  use_date: 'use_date_example', # String | If set to \"sent\", use the date the message was sent, instead of the date of the open event, for date selections.
  detail: 'detail_example', # String | Boolean.  If 1, include the values of all Contact Custom Fields in the report. Default is 0.
  email: 'email_example', # String | Filter results by matching any Contact email address containing the given string.
  domain: 'domain_example', # String | Filter results by matching any Contact email address in a domain name containing the given string.
  after_date: 'after_date_example', # String | DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT
  before_date: 'before_date_example', # String | DATETIME. Return only matches dated before this date time.
  first_row: 0, # Integer | (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row=50000 to get rows 50000 to 99,999.
  from_date: 'from_date_example', # String | DATETIME. Return only matches dated on or after this date time.
  matches: 50000, # Integer | (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets.
  through_date: 'through_date_example', # String | DATETIME. Return only matches dated before or on this date time.
  destination: 'destination_example', # String | For reporting requests.  Specifying a destination makes the report \"asynchronous.\"  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \"job number\" and the filename that will be uploaded.  The supported value of \"destination\" is currently only \"sftp\" for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \"destination\" is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance.
  destination_directory: 'destination_directory_example', # String | For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \"chdir\" command.
  destination_hostname: 'destination_hostname_example', # String | For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded.
  destination_password: 'destination_password_example', # String | For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded.
  destination_username: 'destination_username_example' # String | For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded.
}

begin
  result = api_instance.get_report_urls(username, opts)
  p result
rescue Luxsci::ApiError => e
  puts "Exception when calling Marketing3Api->get_report_urls: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **username** | **String**|  | 
 **campaign_ids** | **String**| Select campaigns as string of comma-separated campaign ids.  If omitted, all campaigns are selected. | [optional] 
 **use_date** | **String**| If set to \&quot;sent\&quot;, use the date the message was sent, instead of the date of the open event, for date selections. | [optional] 
 **detail** | **String**| Boolean.  If 1, include the values of all Contact Custom Fields in the report. Default is 0. | [optional] 
 **email** | **String**| Filter results by matching any Contact email address containing the given string. | [optional] 
 **domain** | **String**| Filter results by matching any Contact email address in a domain name containing the given string. | [optional] 
 **after_date** | **String**| DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT | [optional] 
 **before_date** | **String**| DATETIME. Return only matches dated before this date time. | [optional] 
 **first_row** | **Integer**| (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row&#x3D;50000 to get rows 50000 to 99,999. | [optional] [default to 0]
 **from_date** | **String**| DATETIME. Return only matches dated on or after this date time. | [optional] 
 **matches** | **Integer**| (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets. | [optional] [default to 50000]
 **through_date** | **String**| DATETIME. Return only matches dated before or on this date time. | [optional] 
 **destination** | **String**| For reporting requests.  Specifying a destination makes the report \&quot;asynchronous.\&quot;  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \&quot;job number\&quot; and the filename that will be uploaded.  The supported value of \&quot;destination\&quot; is currently only \&quot;sftp\&quot; for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \&quot;destination\&quot; is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance. | [optional] 
 **destination_directory** | **String**| For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \&quot;chdir\&quot; command. | [optional] 
 **destination_hostname** | **String**| For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded. | [optional] 
 **destination_password** | **String**| For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded. | [optional] 
 **destination_username** | **String**| For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded. | [optional] 

### Return type

[**InlineResponse20034**](InlineResponse20034.md)

### Authorization

Authorization handled with secret key and public token provided

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json



# **update_campaign**
> InlineResponse201 update_campaign(usernamecampaign_id, opts)



Update information for existing Campaign. {{ACL: Marketing - Campaign Management}}

### Example
```ruby
# load the gem
require 'luxsci'

api_instance = Luxsci::Marketing3Api.new
username = 'username_example' # String | 
campaign_id = 'campaign_id_example' # String | Campaign Id.
opts = { 
  body: Luxsci::SM3CampaignPUTBody.new # SM3CampaignPUTBody | 
}

begin
  result = api_instance.update_campaign(usernamecampaign_id, opts)
  p result
rescue Luxsci::ApiError => e
  puts "Exception when calling Marketing3Api->update_campaign: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **username** | **String**|  | 
 **campaign_id** | **String**| Campaign Id. | 
 **body** | [**SM3CampaignPUTBody**](SM3CampaignPUTBody.md)|  | [optional] 

### Return type

[**InlineResponse201**](InlineResponse201.md)

### Authorization

Authorization handled with secret key and public token provided

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json



# **update_contact**
> InlineResponse201 update_contact(bodyusernamecontact_id, opts)



Update information for existing Contact such as E-mail address or custom fields attached to the parent List. {{ACL: Marketing - Contact Management}}

### Example
```ruby
# load the gem
require 'luxsci'

api_instance = Luxsci::Marketing3Api.new
body = {
  "email" : "support@luxsci.com",
  "customer_id_custom_field" : 999,
  "list_id" : "28"
} # Hash<String, String> | A JSON object containing Contact properties.
username = 'username_example' # String | 
contact_id = 'contact_id_example' # String | Contact Id.
opts = { 
}

begin
  result = api_instance.update_contact(bodyusernamecontact_id, opts)
  p result
rescue Luxsci::ApiError => e
  puts "Exception when calling Marketing3Api->update_contact: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**Hash&lt;String, String&gt;**](Hash.md)| A JSON object containing Contact properties. | 
 **username** | **String**|  | 
 **contact_id** | **String**| Contact Id. | 

### Return type

[**InlineResponse201**](InlineResponse201.md)

### Authorization

Authorization handled with secret key and public token provided

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json



# **update_list**
> InlineResponse201 update_list(bodyusernameid, opts)



Update information for existing Contact Lists such as From Name or From Address. This can also be used to assign custom fields to specific lists, but the custom field must exist in the platform in advance. Return contact information and other general metadata for the user. {{ACL: Marketing - List Management}}

### Example
```ruby
# load the gem
require 'luxsci'

api_instance = Luxsci::Marketing3Api.new
body = Luxsci::SM3ListBody.new # SM3ListBody | A JSON object containing List properties.
username = 'username_example' # String | 
id = 'id_example' # String | List Id.
opts = { 
}

begin
  result = api_instance.update_list(bodyusernameid, opts)
  p result
rescue Luxsci::ApiError => e
  puts "Exception when calling Marketing3Api->update_list: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**SM3ListBody**](SM3ListBody.md)| A JSON object containing List properties. | 
 **username** | **String**|  | 
 **id** | **String**| List Id. | 

### Return type

[**InlineResponse201**](InlineResponse201.md)

### Authorization

Authorization handled with secret key and public token provided

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json



# **update_list_group**
> InlineResponse2003 update_list_group(usernamelist_group_id, opts)



Update the List Group name. {{ACL: Marketing - List Management}}

### Example
```ruby
# load the gem
require 'luxsci'

api_instance = Luxsci::Marketing3Api.new
username = 'username_example' # String | 
list_group_id = 'list_group_id_example' # String | Unique Id for this list group.
opts = { 
  body: Luxsci::ListGroupListGroupIdBody1.new # ListGroupListGroupIdBody1 | 
}

begin
  result = api_instance.update_list_group(usernamelist_group_id, opts)
  p result
rescue Luxsci::ApiError => e
  puts "Exception when calling Marketing3Api->update_list_group: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **username** | **String**|  | 
 **list_group_id** | **String**| Unique Id for this list group. | 
 **body** | [**ListGroupListGroupIdBody1**](ListGroupListGroupIdBody1.md)|  | [optional] 

### Return type

[**InlineResponse2003**](InlineResponse2003.md)

### Authorization

Authorization handled with secret key and public token provided

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json



